jQuery(document).ready(function($) {

	var gallery_images = $('#gallery_images');

	$( "#gallery_images" ).sortable({
		placeholder: "placeholder",
		containment: "parent",
		cancel: "#upload_gallery_images",
		items: ".image",
		revert: true
	});

	$('#upload_gallery_images').click(function(){
		var button = $(this);
		
		var frame = wp.media({
			title : gallery_strings.select_title,
			multiple : true,
			button : { text : gallery_strings.select_button }
		});
		
		frame.on('select',function() {
			attachment = frame.state().get('selection').toJSON();
			$.each(attachment,function(index,attachment){
				var image = $('<div>').addClass('image');
				var input = $('<input type="text" />').attr({
								name: 'gallery_images[]',
								value: attachment.id
							});
				var picture = $('<img />').attr('src',attachment.sizes.thumbnail.url);
				var edit_link = $('<a>').addClass('edit icon-pencil').text(gallery_strings.edit);
				var delete_link = $('<a>').addClass('delete icon-minus-circled').text(gallery_strings.delete);
				var title = $('<strong>').text(attachment.title);
			
				image.append(input,picture,edit_link,delete_link,title);
				button.before(image);
				
				gallery_images.removeClass('no_images');
			});
		});
		
		frame.open();
		
		return false;
	});
	
	$(document).on('click', '#gallery_images a.edit', function(e){		
		var id = $(this).parent().find('input').val();
		var title = $(this).parent().find('strong');
		
		var frame = wp.media({
			title : gallery_strings.edit_title,
			multiple : true,
			button : { text : gallery_strings.edit_button }
		});

		frame.on('select',function() {
			attachment = frame.state().get('selection').toJSON();
			$.each(attachment,function(index,attachment){
				title.text(attachment.title);				
			});
		});
		
		frame.on('open',function() {
			frame.$el.addClass('edit_image');
			var selection = frame.state().get('selection');
			ids = [id];
			ids.forEach(function(id) {
				attachment = wp.media.attachment(id);
				attachment.fetch();
				selection.add( attachment ? [ attachment ] : [] );
			});
 		});
 		
 		frame.on('close',function() {
			frame.$el.removeClass('edit_image');
 		});

		frame.open();
		
		return false;
	});

	$(document).on('click', '#gallery_images a.delete', function(e){
		$(this).parent().remove();
		var length = $('#gallery_images .image').length;
		if (!length) {
			gallery_images.addClass('no_images');
		}
		return false;
	});
	
	$('#gallery_shortcode_generator input').change(function(){
		var inputs = $('#gallery_shortcode_generator');
		var type = $(this).attr('type');
		var title = '';
		var description = '';
		var type = '';
		var id = $('.shortcode_gen_radios').attr('id');
		
		if (inputs.find('input[name="show_title"]').is(':checked')) title = ' title="true"';
		if (inputs.find('input[name="show_description"]').is(':checked')) description = ' description="true"';
		
		if (inputs.find('input[value="gallery"]').is(':checked')) type = '';
		if (inputs.find('input[value="scrollable"]').is(':checked')) type = ' type="scrollable"';
		if (inputs.find('input[value="summary"]').is(':checked')) type = ' type="summary"';

		shortcode = '[wedding_gallery id="'+id+'"'+type+title+description+']';
	
		$('#gallery_shortcode_generator textarea').val(shortcode);
	}).change();
});