<?php

//Global Shortcode Optimalization
add_filter( 'gc_column_content', 'do_shortcode' );
add_filter( 'widget_text', 'shortcode_unautop');
add_filter( 'widget_text', 'do_shortcode');
//Global Shortcode Optimalization

//Feature List Shortcode - [feature_list size="big"][item icon="home" title="title"]content[/item][/feature_list]
function wedding_feature_list($atts, $content = null) {
	extract(shortcode_atts(array(
		"size" => 'big'
	), $atts));
	
	return '<ul class="feature_list '.$size.'">'.do_shortcode($content).'</ul><div class="clear"></div>';
}
add_shortcode('feature_list', 'wedding_feature_list');

function feature_list_item($atts, $content = null) {
	extract(shortcode_atts(array(
		"icon" => '',
		"title" => ''
	), $atts));
	return '<li><h2 class="icon-'.$icon.'">'.$title.'</h2>'.do_shortcode($content).'</li>';
}
add_shortcode('item', 'feature_list_item');
//Feature List Shortcode

//Social icons - [social type="facebook"]
add_shortcode( 'social', 'social_shortcode' );
function social_shortcode( $atts ){
	extract(shortcode_atts(array(
		'type' => 'facebook',
		'href' => '#'
	), $atts));
	
	if (wedding_field('social_href_'.$type)) {
		$href = wedding_field('social_href_'.$type);
	}

	return '<a href="'.$href.'" class="social_icon icon-'.$type.'"></a>';
}
//Social icons

//Columns
function theme_shortcode_column($atts, $content = null, $code) {
	

	return '<div class="'.$code.'">' . apply_filters( 'gc_column_content', $content ) . '</div>';
	//return '<div class="'.$code.'">' . do_shortcode(trim($content)) . '</div>';
}
function theme_shortcode_column_last($atts, $content = null, $code) {
	return '<div class="'.str_replace('_last','',$code).' last">' . apply_filters( 'gc_column_content', $content ) . '</div><div class="clear"></div>';
	//return '<div class="'.str_replace('_last','',$code).' last">' . do_shortcode(trim($content)) . '</div><div class="clear"></div>';
}

add_shortcode('one_half', 'theme_shortcode_column');
add_shortcode('one_third', 'theme_shortcode_column');
add_shortcode('one_fourth', 'theme_shortcode_column');

add_shortcode('two_third', 'theme_shortcode_column');
add_shortcode('three_fourth', 'theme_shortcode_column');

add_shortcode('one_half_last', 'theme_shortcode_column_last');
add_shortcode('one_third_last', 'theme_shortcode_column_last');
add_shortcode('one_fourth_last', 'theme_shortcode_column_last');

add_shortcode('two_third_last', 'theme_shortcode_column_last');
add_shortcode('three_fourth_last', 'theme_shortcode_column_last');
//Columns

//Tabs - [tabs toggle="true"][tab title="Tab 1"]tab content...[/tab][/tabs]
add_shortcode( 'tabs', 'jqtools_tab_group' );
function jqtools_tab_group( $atts, $content ){
extract(shortcode_atts(array(
'toggle' => false
), $atts));
$GLOBALS['tab_count'] = 0;

do_shortcode( $content );
if( is_array( $GLOBALS['tabs'] ) ){
	if ($toggle) {
		foreach( $GLOBALS['tabs'] as $tab ){
			$tabs[] = '<div class="tab"><a class="tab_title header-font" href="#">'.$tab['title'].'</a><section>'.do_shortcode($tab['content']).'</section></div>';
		}
		$return = "".'<div class="toggle">'.implode( "\n", $tabs ).'</div>'."";
	}
	else {
		foreach( $GLOBALS['tabs'] as $tab ){
			$tabs[] = '<a class="header-font" href="#">'.$tab['title'].'</a>';
			$panes[] = '<section>'.do_shortcode($tab['content']).'</section>';
		}
		$return = "\n".'<div class="tabs"><nav>'.implode( "\n", $tabs ).'</nav>'."\n".'<div class="panes">'.implode( "\n", $panes ).'</div></div>'."\n";
	}
}
return $return;
}

add_shortcode( 'tab', 'jqtools_tab' );
function jqtools_tab( $atts, $content ){
extract(shortcode_atts(array(
'title' => 'Tab %d'
), $atts));

$x = $GLOBALS['tab_count'];
$GLOBALS['tabs'][$x] = array( 'title' => sprintf( $title, $GLOBALS['tab_count'] ), 'content' =>  $content );

$GLOBALS['tab_count']++;
}
//Tabs

//Box - [box title="Title"]content...[/box]
add_shortcode( 'box', 'box_shortcode' );
function box_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'title' => '',
		'icon' => ''
	), $atts));
	
	if ($icon) $icon = ' box-icon icon-'.$icon;
	$box_title = '<h4 class="title">'.$title.'</h4>';
	if (!$title) $box_title = '';
	
	return '<div class="box'.$icon.'">'.$box_title.''. apply_filters( 'gc_column_content', $content ) . '</div>';
}
//Box

//Messages [message type="error"]Message content...[/message]
add_shortcode( 'message', 'message_shortcode' );
function message_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'type' => ''
	), $atts));
	return '<div class="message '.$type.'">' . do_shortcode($content) . '</div>';
}
//Messages

//Divider
add_shortcode( 'divider', 'divider_shortcode' );
function divider_shortcode( $atts, $content=null ){
	extract(shortcode_atts(array(
		'type' => ''
	), $atts));
	$link = '';
	if ($type == 'top') {
		$link = '<a href="#top">'.__('top','wedding').'</a>';
	}
	return '<div class="hr '.$type.'">'.$link.'</div>';
}
//Divider

//Buttons
add_shortcode( 'button', 'button_shortcode' );
function button_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'url' => '#',
		'color' => '',
		'size' => '',
		'icon' => '',
		'fancybox' => ''
	), $atts));
	$style = '';
	if (strpos($color,'#') !== false) {
		$style = ' style="background:'.$color.';"';
		$color = 'other';
	}
	if ($icon) $icon = 'icon-'.$icon;
	if ($fancybox == 'iframe') $fancybox = ' rel="fancybox-iframe"';
	return '<a href="'.$url.'" class="button '.$color.' '.$size.' '.$icon.'"'.$style.$fancybox.'>'.$content.'</a>';
}
//Buttons

//Maps
add_shortcode( 'maps', 'maps_shortcode' );
function maps_shortcode( $atts,$content ){

	wp_enqueue_script('wedding-google-maps','http://maps.google.com/maps/api/js?sensor=true');
	wp_enqueue_script('wedding-ui-maps', get_template_directory_uri() . '/js/maps.js');

	extract(shortcode_atts(array(
		'title' => '',
		'description' => '',
		'coordinates' => '0,0',
		'zoom' => 10,
		'height' => ''
	), $atts));
	
	$description = nl2br($description);
	if (!$description) $description = $content;
	
	if ($height) $height = 'style="height:'.$height.'"';
	
	return '<div class="wedding_google_maps box" data-coordinates="'.$coordinates.'" data-title="'.$title.'" data-description="'.$description.'" data-zoom="'.$zoom.'"><div class="map" '.$height.'></div></div>';
}
//Maps

//List Shortcode [list icon="check"]List content...[/list]
add_shortcode( 'list', 'list_shortcode' );
function list_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'icon' => 'check'
	), $atts));
	return '<div class="list_icon" data-icon="icon-'.$icon.'">' . do_shortcode($content) . '</div>';
}
//List Shortcode

//Recent Posts
add_shortcode( 'recent_posts', 'recent_posts_shortcode' );
function recent_posts_shortcode( $atts ){
	global $post;
	extract(shortcode_atts(array(
		'count' => 4
	), $atts));
	
	ob_start();
	the_widget('WP_Widget_Recent_Posts',array('number'=>$count,'show_date'=>true),array('before_title'=>'<h4>','after_title'=>'</h4>'));
	$output = ob_get_contents();
    ob_end_clean();
    return $output;
}
//Recent Posts

//Dropcaps
add_shortcode( 'dropcap', 'dropcap_shortcode' );
function dropcap_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'type' => ''
	), $atts));
	if ($type=='v2') {
		$type = $type.' primary-color';
	}
	return '<span class="dropcap '.$type.'">'.$content.'</span>';
}
//Dropcaps

//Highlight
add_shortcode( 'highlight', 'highlight_shortcode' );
function highlight_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'class' => ''
	), $atts));
	return '<span class="highlight '.$class.'">'.$content.'</span>';
}
//Highlight

//Section Title
add_shortcode( 'section_title', 'section_title_shortcode' );
function section_title_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'class' => ''
	), $atts));
	return '<header class="section-title '.$class.'"><h1><span>'.$content.'</span></h1></header>';
}
//Section Title

//Icon List Shortcode
function icon_list_shortcode($atts, $content = null) {
	return '<ul class="icon_list">'.apply_filters( 'gc_column_content', $content ).'</ul><div class="clear"></div>';
}
add_shortcode('icon_list', 'icon_list_shortcode');

function list_item_shortcode($atts, $content = null) {
	extract(shortcode_atts(array(
		"icon" => 'leaf'
	), $atts));
	return '<li class="icon-'.$icon.'">'.do_shortcode($content).'</li>';
}
add_shortcode('list_item', 'list_item_shortcode');
//Icon List Shortcode

//Popular Posts
add_shortcode( 'popular_posts', 'popular_posts_shortcode' );
function popular_posts_shortcode( $atts ){
	global $post;
	extract(shortcode_atts(array(
		'count' => 4
	), $atts));
	
	ob_start();
	the_widget('Wedding_Widget_Popular_Posts',array('number'=>$count,'show_date'=>true),array('before_title'=>'<h4>','after_title'=>'</h4>'));
	$output = ob_get_contents();
    ob_end_clean();
    return $output;
}
//Popular Posts

//TinyMCE Shortcode Buttons
add_action('init', 'wedding_add_tinymce_button');
function wedding_add_tinymce_button() {  
	if ( current_user_can('edit_posts') &&  current_user_can('edit_pages') ) {  
		add_filter('mce_external_plugins', 'wedding_add_tinymce_plugin');  
		add_filter('mce_buttons_3', 'wedding_register_tinymce_button');  
	}  
}  

function wedding_register_tinymce_button($buttons) {  
   array_push($buttons, "feature_list","social","one_half","one_third","one_fourth","two_third","three_fourth","tabs","box","message","divider","button","maps","list","recent_posts","dropcap","highlight","gallery");  
   return $buttons;  
}  

function wedding_add_tinymce_plugin($plugin_array) {  
   $plugin_array['feature_list'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['social'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['one_half'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['one_third'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['one_fourth'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['two_third'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['three_fourth'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['tabs'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['box'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['message'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['divider'] = get_template_directory_uri().'//includes/static/tinymce.js';
   $plugin_array['button'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['maps'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['list'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['recent_posts'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['dropcap'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['highlight'] = get_template_directory_uri().'/includes/static/tinymce.js';
   $plugin_array['gallery'] = get_template_directory_uri().'/includes/static/tinymce.js';
   
   return $plugin_array;  
}  
//TinyMCE Shortcode Buttons

?>