<?php

//Slider Post Type
add_action('init', 'register_wedding_slider_post_type');
function register_wedding_slider_post_type() {

	register_post_type(
		'wedding_slider',
		array(
			'labels' => array(
				'name' => __('Sliders','wedding'),
				'singular_name' => __('Slider','wedding')
			),
			'public' => false,
			'show_ui' => true,
			'has_archive' => true,
			'publicly_queryable' => true,
			'supports' => array('title'),
			'menu_icon' => get_template_directory_uri() . '/includes/slider/slideshow.png'
		)
	);

}
//Slider Post Type

//Slider metabox left side
add_action('admin_init', 'register_wedding_slider_slide_box');
add_action('save_post', 'save_wedding_slider_slide_box',10,2);

function register_wedding_slider_slide_box() {
	add_meta_box('wedding_slider_slides', 'Slider Options', 'wedding_slider_slide_box_callback', 'wedding_slider', 'normal', 'low');
}

function video_image($url){
	$image_url = parse_url($url);
	if (isset($image_url['host'])) {
		if($image_url['host'] == 'www.youtube.com' || $image_url['host'] == 'youtube.com'){
			$array = explode("&", $image_url['query']);
			return "http://img.youtube.com/vi/".substr($array[0], 2)."/maxresdefault.jpg";
		} else if($image_url['host'] == 'www.vimeo.com' || $image_url['host'] == 'vimeo.com'){
			return 'vimeo-thumbnail';
		}
	}
}

function wedding_slider_slide_box_callback() {
	global $post;
	$custom = get_post_custom($post->ID);
	$slide_data = '';
	if (isset($custom['slide_data'][0])) $slide_data = $custom['slide_data'][0];
	
	wp_nonce_field( basename( __FILE__ ), 'wedding_slider_slide_nonce' );
	
	if ( ! did_action( 'wp_enqueue_media' ) )
    wp_enqueue_media();

    wp_enqueue_script('wedding_slider_admin_js', get_template_directory_uri().'/includes/slider/slider.js');
    wp_enqueue_style('wedding_slider_admin_css', get_template_directory_uri().'/includes/slider/slider.css');

	?>
	
	<div id="slides" style="display:none;">
		
		<?php if($slide_data): $slide_data = unserialize($slide_data); foreach($slide_data as $key => $slide): ?>
		
			<div class="slide">
				<header>
					<span><em><?php echo $key; ?>.</em> <?php _e('slide','wedding'); ?></span>
					<nav>
						<a href="#" class="icon-docs duplicate"><?php _e('duplicate','wedding'); ?></a>
						<a href="#" class="icon-minus-circled delete"><?php _e('delete','wedding'); ?></a>
					</nav>
				</header>
				<div class="body">
					<div class="left">
						<?php
						$bg = '';
						if ($slide['image']!='') {
							if (video_image($slide['image']) != '') {
								$bg = 'style="background-image:url('.video_image($slide['image']).')"';
							} else {
								$image = wp_get_attachment_url($slide['image']);
								$bg = 'style="background-image:url('.$image.')"';
							}
						} 
						?>
						<div class="image<?php if($slide['image']!=''):?> hasimg<?php endif; ?>" <?php echo $bg; ?>>
							<input type="text" name="slide_data[<?php echo $key; ?>][image]" value="<?php echo $slide['image']; ?>" />
							<a href="#" class="icon-upload-cloud upload"><?php _e('Upload Image','wedding'); ?></a>
							<a href="#" class="upload_video" title="<?php _e('Youtube or Vimeo link','wedding'); ?>"><?php _e('or video','wedding'); ?></span></a>
						</div>
					</div>
					<div class="right">
						<p>
							<label><?php _e('Image Caption','wedding'); ?> <em><?php _e('you can use html code','wedding'); ?></em></label>
							<textarea name="slide_data[<?php echo $key; ?>][caption]"><?php echo $slide['caption']; ?></textarea>
							<span class="caption_position">
								<a href="tl" <?php if($slide['caption_position']=='caption tl' || $slide['caption_position']==''):?>class="active"<?php endif; ?> title="<?php _e('Top Left','wedding'); ?>"></a>
								<a href="tc" <?php if($slide['caption_position']=='caption tc'):?>class="active"<?php endif; ?> title="<?php _e('Top Center','wedding'); ?>"></a>
								<a href="tr" <?php if($slide['caption_position']=='caption tr'):?>class="active"<?php endif; ?> title="<?php _e('Top Right','wedding'); ?>"></a>
								<a href="cl" <?php if($slide['caption_position']=='caption cl'):?>class="active"<?php endif; ?> title="<?php _e('Center Left','wedding'); ?>"></a>
								<a href="cc" <?php if($slide['caption_position']=='caption cc'):?>class="active"<?php endif; ?> title="<?php _e('Center','wedding'); ?>"></a>
								<a href="cr" <?php if($slide['caption_position']=='caption cr'):?>class="active"<?php endif; ?> title="<?php _e('Center Right','wedding'); ?>"></a>
								<a href="bl" <?php if($slide['caption_position']=='caption bl'):?>class="active"<?php endif; ?> title="<?php _e('Bottom Left','wedding'); ?>"></a>
								<a href="bc" <?php if($slide['caption_position']=='caption bc'):?>class="active"<?php endif; ?> title="<?php _e('Bottom Center','wedding'); ?>"></a>
								<a href="br" <?php if($slide['caption_position']=='caption br'):?>class="active"<?php endif; ?> title="<?php _e('Bottom Right','wedding'); ?>"></a>
								<input type="hidden" name="slide_data[<?php echo $key; ?>][caption_position]" value="<?php echo $slide['caption_position']; ?>" />
							</span>
						</p>
						<p>
							<label><?php _e('Image Link','wedding'); ?> <em>e.g. http://google.com</em></label>
							<input name="slide_data[<?php echo $key; ?>][link]" type="text" value="<?php echo $slide['link']; ?>" />
							<a href="#" class="icon-popup link_target <?php if($slide['link_target'] == '1'): ?>active<?php endif; ?>" title="<?php _e('Open in new window','wedding'); ?>"></a>
							<input class="link_target_input" type="hidden" name="slide_data[<?php echo $key; ?>][link_target]" value="<?php echo $slide['link_target']; ?>" />
						</p>
					</div>
					<div class="clear"></div>
				</div>
			</div>
		
		<?php endforeach; endif; ?>
	</div>
	
		<div class="slide" id="slide_empty" style="display:none">
			<header>
				<span><em>1.</em> <?php _e('slide','wedding'); ?></span>
				<nav>
					<a href="#" class="icon-docs duplicate"><?php _e('duplicate','wedding'); ?></a>
					<a href="#" class="icon-minus-circled delete"><?php _e('delete','wedding'); ?></a>
				</nav>
			</header>
			<div class="body">
				<div class="left">
					<div class="image">
						<input type="text" name="image" />
						<a href="#" class="icon-upload-cloud upload"><?php _e('Upload Image','wedding'); ?></a>
						<a href="#" class="upload_video"title="<?php _e('Youtube or Vimeo link','wedding'); ?>"><?php _e('or video','wedding'); ?></span></a>
					</div>
				</div>
				<div class="right">
					<p>
						<label><?php _e('Image Caption','wedding'); ?> <em><?php _e('you can use html code','wedding'); ?></em></label>
						<textarea name="caption"></textarea>
						<span class="caption_position">
							<a href="tl" class="active" title="<?php _e('Top Left','wedding'); ?>"></a>
							<a href="tc" title="<?php _e('Top Center','wedding'); ?>"></a>
							<a href="tr" title="<?php _e('Top Right','wedding'); ?>"></a>
							<a href="cl" title="<?php _e('Center Left','wedding'); ?>"></a>
							<a href="cc" title="<?php _e('Center','wedding'); ?>"></a>
							<a href="cr" title="<?php _e('Center Right','wedding'); ?>"></a>
							<a href="bl" title="<?php _e('Bottom Left','wedding'); ?>"></a>
							<a href="bc" title="<?php _e('Bottom Center','wedding'); ?>"></a>
							<a href="br" title="<?php _e('Bottom Right','wedding'); ?>"></a>
							<input type="hidden" name="caption_position" value="tl" />
						</span>
					</p>
					<p>
						<label><?php _e('Image Link','wedding'); ?> <em>e.g. http://google.com</em></label>
						<input name="link" type="text" />
						<a href="#" class="icon-popup link_target" title="<?php _e('Open in new window','wedding'); ?>"></a>
						<input class="link_target_input" type="hidden" name="link_target" value="0" />
					</p>
				</div>
				<div class="clear"></div>
			</div>
		</div>
	
	<a href="#" class="icon-plus-circled" id="add_slide"><?php _e('Create a new slide','wedding'); ?></a>
	<?php
}

function save_wedding_slider_slide_box($post_id, $post) {
	global $post;

	if ( !isset( $_POST['wedding_slider_slide_nonce'] ) || !wp_verify_nonce( $_POST['wedding_slider_slide_nonce'], basename( __FILE__ ) ) )
		return $post_id;

	$post_type = get_post_type_object( $post->post_type );

	if ( !current_user_can( $post_type->cap->edit_post, $post_id ) )
		return $post_id;

	$post_meta = array();
	if (isset($_POST['slide_data'])) $post_meta['slide_data'] = $_POST['slide_data'];

	foreach ($post_meta as $key => $value) {
		$new_meta_value = ( isset( $value ) ? $value : '' );
		$meta_key = $key;
		$meta_value = get_post_meta( $post_id, $meta_key, true );
		if ( $new_meta_value && '' == $meta_value )
			add_post_meta( $post_id, $meta_key, $new_meta_value, true );
		elseif ( $new_meta_value && $new_meta_value != $meta_value )
			update_post_meta( $post_id, $meta_key, $new_meta_value );
		elseif ( '' == $new_meta_value && $meta_value )
			delete_post_meta( $post_id, $meta_key, $meta_value );
	}
}
//Slider metabox left side

//Additional metabox for slider options
add_action( 'post_submitbox_misc_actions', 'register_slider_additionals' );
add_action( 'save_post', 'save_slider_additionals',10,2 );
function register_slider_additionals() {
    global $post;
    if (get_post_type($post) == 'wedding_slider') {
		$custom = get_post_custom($post->ID);

		$slider_autoplay = '';
		if (isset($custom['slider_autoplay'][0])) $slider_autoplay = $custom['slider_autoplay'][0];
		$slider_autoplay_delay = '';
		if (isset($custom['slider_autoplay_delay'][0])) $slider_autoplay_delay = $custom['slider_autoplay_delay'][0];
		$slider_height = '';
		if (isset($custom['slider_height'][0])) $slider_height = $custom['slider_height'][0];
		$slider_fade = '';
		if (isset($custom['slider_fade'][0])) $slider_fade = $custom['slider_fade'][0];
	
		wp_nonce_field( basename( __FILE__ ), 'slider_additionals' );
	
		?>
		<div class="misc-pub-section">
			<strong><?php _e('Autoplay:','wedding'); ?></strong> 
			<input type="checkbox" value="1" name="slider_autoplay" <?php if($slider_autoplay): ?> checked="checked"<?php endif; ?> />
		</div>
		<div class="misc-pub-section slider-extra" id="autoplay-delay" <?php if(!$slider_autoplay): ?>style="display:none;"<?php endif; ?>>
			<strong><?php _e('Delay:','wedding'); ?></strong>
			<input type="text" value="<?php echo $slider_autoplay_delay; ?>" name="slider_autoplay_delay" placeholder="3000" /> <em>ms</em>
		</div>
		<div class="misc-pub-section slider-extra">
			<strong><?php _e('Height:','wedding'); ?></strong> 
			<input type="text" value="<?php echo $slider_height; ?>" name="slider_height" placeholder="500px" />
		</div>
		<div class="misc-pub-section slider-extra fade-type">
			<strong class="fade <?php if(!$slider_fade): ?>active<?php endif; ?>"><?php _e('Fade','wedding'); ?></strong> 
			<a href="#" <?php if($slider_fade): ?>class="on"<?php endif; ?>><span></span></a>
			<input type="checkbox" value="1" name="slider_fade" <?php if($slider_fade): ?> checked="checked"<?php endif; ?> />
			<strong class="slide <?php if($slider_fade): ?>active<?php endif; ?>"><?php _e('Slide','wedding'); ?></strong> 
			<div class="clear"></div>
		</div>
		<?php
		global $pagenow;
		if ($pagenow == 'post.php'):
		?>
		<div class="misc-pub-section">
			<strong><?php _e('Shortcode:','wedding'); ?></strong>
			[slider id="<?php echo $post->ID; ?>"]
		</div>
		<?php endif; ?>
    <?php
    }
}
function save_slider_additionals($post_id, $post) {
 
	global $post;
	
	if ( !isset( $_POST['slider_additionals'] ) || !wp_verify_nonce( $_POST['slider_additionals'], basename( __FILE__ ) ) )
		return $post_id;

	$post_type = get_post_type_object( $post->post_type );

	if ( !current_user_can( $post_type->cap->edit_post, $post_id ) )
		return $post_id;

	$post_meta = array();
	if (isset($_POST['slider_autoplay'])) $post_meta['slider_autoplay'] = $_POST['slider_autoplay'];
	if (isset($_POST['slider_autoplay_delay'])) $post_meta['slider_autoplay_delay'] = $_POST['slider_autoplay_delay'];
	if (isset($_POST['slider_height'])) $post_meta['slider_height'] = $_POST['slider_height'];
	if (isset($_POST['slider_fade'])) $post_meta['slider_fade'] = $_POST['slider_fade'];

	foreach ($post_meta as $key => $value) {
		$new_meta_value = ( isset( $value ) ? $value : '' );
		$meta_key = $key;
		$meta_value = get_post_meta( $post_id, $meta_key, true );
		if ( $new_meta_value && '' == $meta_value )
			add_post_meta( $post_id, $meta_key, $new_meta_value, true );
		elseif ( $new_meta_value && $new_meta_value != $meta_value )
			update_post_meta( $post_id, $meta_key, $new_meta_value );
		elseif ( '' == $new_meta_value && $meta_value )
			delete_post_meta( $post_id, $meta_key, $meta_value );
	}
 
}
//Additional metabox for slider options

//Add post type class to body in admin
function add_to_admin_body_class( $classes ) {
	global $post;
	$mode = '';
	$uri = $_SERVER["REQUEST_URI"];
	$post_type = '';
	if ($post) $post_type = get_post_type($post->ID);
	if (strstr($uri,'edit.php')) {
		$mode = 'edit-list-';
	}
	if (strstr($uri,'post.php')) {
		$mode = 'edit-page-';
	}
	$classes .= $mode . $post_type;
	return $classes;
}
add_filter('admin_body_class', 'add_to_admin_body_class');
//Add post type class to body in admin

//Slider Custom Table and another modifications
function slider_custom_columns($columns) {
	$columns = array(
		'cb'	 	=> '<input type="checkbox" />',
		'title' 	=> __('Slider','wedding'),
		'shortcode'	=>	'Shortcode',
		'date'		=>	__('Date','wedding'),
	);
	return $columns;
}

function slider_custom_columns_data($column) {
	global $post;
	if($column == 'shortcode')
	{
		echo '[slider id="'.$post->ID.'"]';
	}
}
 
add_action("manage_wedding_slider_posts_custom_column", "slider_custom_columns_data");
add_filter("manage_edit-wedding_slider_columns", "slider_custom_columns");
//Slider Custom Table and another modifications

//Slider shortcode
add_shortcode( 'slider', 'slider_shortcode' );
function slider_shortcode( $atts, $content ){
	extract(shortcode_atts(array(
		'id' => '0'
	), $atts));
	
	global $post;
	$custom = get_post_custom($id);
	$slide_data = '';
	if (isset($custom['slide_data'][0])) $slide_data = $custom['slide_data'][0];

	$slider_autoplay = false;
	if (isset($custom['slider_autoplay'][0])) $slider_autoplay = $custom['slider_autoplay'][0];
	$slider_autoplay_delay = '3000';
	if (isset($custom['slider_autoplay_delay'][0])) $slider_autoplay_delay = $custom['slider_autoplay_delay'][0];
	$slider_height = '500px';
	if (isset($custom['slider_height'][0])) $slider_height = $custom['slider_height'][0];

	$slider_fade = 1;
	if (isset($custom['slider_fade'][0])) $slider_fade = $custom['slider_fade'][0]+1;


	$slider = '';

	if($slide_data):
		
		if ($slider_autoplay) {
			$slider .= '<div class="weddingSlider" style="width: 100%; height: '.$slider_height.';" data-autoplay="true" data-autoplaydelay="'.$slider_autoplay_delay.'">';
		} else {
			$slider .= '<div class="weddingSlider" style="width: 100%; height: '.$slider_height.';">';
		}
	
		$slide_data = unserialize($slide_data);
		foreach($slide_data as $key => $slide):
		
				$slider .= '<div class="ls-layer" style="transition2d: '.$slider_fade.';">';
			
					
			
					if (video_image($slide['image']) != '') {
					
						$image_url = parse_url($slide['image']);
						if($image_url['host'] == 'www.youtube.com' || $image_url['host'] == 'youtube.com'){
							$array = explode("&", $image_url['query']);
							$slider .= '<div class="ls-s1"><iframe width="960" style="height:'.$slider_height.';" src="http://www.youtube.com/embed/'.substr($array[0], 2).'" frameborder="0" allowfullscreen></iframe></div>';
						} else if($image_url['host'] == 'www.vimeo.com' || $image_url['host'] == 'vimeo.com'){							
							$slider .= '<div class="ls-s1"><iframe src="http://player.vimeo.com/video/'.substr($image_url['path'], 1).'?badge=0" width="960" height="540" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe></div>';
							
						}

					} else {					
						if ($slide['image']) $slider .= '<img src="'.wp_get_attachment_url($slide['image']).'" class="ls-bg" />';
					}
					
					if ($slide['link']):
						if ($slide['link_target']) $slide['link_target'] = 'target="_blank"';
						$slider .= '<a href="'.$slide['link'].'" class="ls-link" '.$slide['link_target'].'></a>';
					endif;
				
					if ($slide['caption']):
						$position = $slide['caption_position'];
						if (!$position) $position = 'tl';
						$style = '';
						if ($position == 'caption tl') $style = 'left:0px;top:30px;';
						if ($position == 'caption tc') $style = 'left:50%;top:30px;';
						if ($position == 'caption tr') $style = 'left:610px;top:30px;';
						if ($position == 'caption cl') $style = 'left:00px;top:50%;';
						if ($position == 'caption cc') $style = 'left:50%;top:50%;';
						if ($position == 'caption cr') $style = 'left:610px;top:50%;';
						if ($position == 'caption bl') $style = 'left:0px;top:70%;';
						if ($position == 'caption bc') $style = 'left:50%;top:70%;';
						if ($position == 'caption br') $style = 'left:610px;top:70%;';
						
						$slider .= '<div style="'.$style.'" class="ls-s2 infoBlock infoBlockLeftBlack '.$position.' rsABlock">'.$slide['caption'].'</div>';
					endif;
				
							
				$slider .= '</div>';
						
		endforeach;
		
		$slider .= '</div>';
	endif;
	

	return $slider;
}

//Slider shortcode