<?php
/*
Template Name: Single Page Layout
*/
get_header(); ?>
	<?php if ( have_posts() ) while ( have_posts() ) : the_post(); ?>
		<div id="<?php echo $post->post_name; ?>">
			<?php echo wedding_homepage_slider(); ?>
			<?php if (get_the_content()): ?>
			<div class="content">
				<section><?php the_content(); ?></section>
			</div>
			<?php endif; ?>
		</div>
		<div class="clear"></div>
	<?php endwhile; ?>
	
	<div class="content single-page-home">
	<?php
	$menu_name = 'header';
	$locations = get_nav_menu_locations();
	$menu = '';
	if ($locations) $menu = wp_get_nav_menu_object( $locations[ $menu_name ] );
	$menu_items = array();
	if ($menu) $menu_items = wp_get_nav_menu_items($menu->term_id);
	$frontpage_id = get_option('page_on_front');
	$postpage_id = get_option( 'page_for_posts' );
	foreach ($menu_items as $section): if ($frontpage_id!=$section->object_id && !$section->menu_item_parent && $section->classes[0] != 'disabled' && $section->type != 'taxonomy'):
	?>
		<?php $page_data = get_page($section->object_id); ?>
		<?php $template = get_post_meta( $section->object_id, '_wp_page_template', true ); ?>
		<section id="<?php echo $page_data->post_name; ?>">
			<header class="section-title">
				<h1><span><?php echo $page_data->post_title; ?></span></h1>
			</header>
			
			<?php //Regular pages or posts ?>
			<?php if ($template == 'default'): ?><?php echo apply_filters('the_content', $page_data->post_content); ?><?php endif; ?>
				
			<?php //Left and Right sidebar pages ?>
			<?php if (strpos($template,'left-sidebar.php') !== false || strpos($template,'right-sidebar.php') !== false): ?>
				<?php $position = 'left'; $position_content = 'right'; if (strpos($template,'right-sidebar.php') !== false){ $position = 'right'; $position_content = 'left';} ?>
				<aside class="<?php echo $position; ?>">
					<ul class="xoxo">
						<?php echo child_pages_navigation($section->object_id); ?>
						<?php $custom_sidebar = get_post_meta($section->object_id, 'page_custom_sidebar', true); ?>
						<?php if($custom_sidebar): ?>
							<?php dynamic_sidebar( $custom_sidebar ); ?>
						<?php else: ?>
							<?php dynamic_sidebar( $position.'-widget-area' ); ?>
						<?php endif; ?>
					</ul>
				</aside>
				<div class="has_sidebar <?php echo $position_content; ?>">		
					<?php echo apply_filters('the_content', $page_data->post_content); ?>
				</div>
				<div class="clear"></div>
			<?php endif; ?>
			
			<?php //Gallery page ?>
			<?php if (strpos($template,'gallery.php') !== false): ?><?php $gallery_url = get_permalink($section->object_id); get_template_part('content', 'gallery' ); ?><?php endif; ?>
			
			<?php //Blog list page ?>
			<?php if ($postpage_id == $section->object_id): ?><?php $blog_url = get_permalink($section->object_id); get_template_part('content', 'blog' ); ?><?php endif; ?>
			
			<?php //Timeline page ?>
			<?php if (strpos($template,'timeline.php') !== false): ?><?php include(locate_template('content-timeline.php')); ?><?php endif; ?>
		</section>
		<div class="hr double"></div>
	<?php endif; endforeach; ?>
	</div>
<?php get_footer(); ?>